/*
	HandleStream routines
	Easy in-core one-way formatting.
	1994 Echo Software.  All Rights Reserved.
	
   who		when		rev	what
*  ____________________________________
*  CKT		5/16/94		001	Created.
*    
*/

#define kSafetyFactor 20	//# bytes to allocate as a safety margin

#include "HandleStream.h"

/* Create a new stream */
Handle NewStream(void)
{
	return NewHandle(40);//if we can't allocate this much, we're in trouble
}

void DisposeStream(Handle stream)
{
	DisposeHandle(stream);
}

void LockStream(Handle stream)
{
	HLockHi(stream);
}

void UnlockStream(Handle stream)
{
	HUnlock(stream);
}

/* Append newData to stream*/
Boolean AddToStream(Handle stream,void *newData,long dataLen)
{
	Boolean	out=true;
	long	streamLen=GetHandleSize(stream);
	
	SetHandleSize(stream,streamLen+dataLen);
	
	if(MemError()==noErr){
		HLockHi(stream);
		BlockMove(newData,*stream+(streamLen-1),dataLen);
		HUnlock(stream);
	}else out=false;
	
	return out;
}