/*
	CWindowGame
	1994 Chris K. Thomas.  All Rights Reserved.
*/


#include "CWindowGame.h"
#include "GrafUtils.h"
#include "SpriteBlizzard.h"
#include "songs.h"
#include "xvApplication.h"
#include "polygons.h"

//extern struct directTB;

struct {
	short	numLives;
	short	energy;
}Player;

extern GWorldPtr	backG;
extern GWorldPtr	constructG;
extern GameWindow	*gGameWindow;

extern long	fps;
short		currentShot;
Rect		sptemp={0,0,200,400};
const short	kShotLeft=30;
const short	kShotRight=-30;

short		UpKey;
short		DownKey;
short		LeftKey;
short		RightKey;
short		FireKey;
	
//planeOfConfusion**	level;	well use this again, when we get objects installed.

ManyPoly**			levelPolys;
unsigned long		oldShotTicks;
Boolean				isGameOff;	//not necessarily over, just frozen.
Sprite				*player,
					*shot,
					*enemy1;
	
Boolean KeyIsDown(short keyCode);

/** MoveProcs **/
void PlayerMoveProc(Sprite* s);
void ShotMoveRightProc(Sprite* s);
void ShotMoveLeftProc(Sprite* s);

#pragma segment MITORIWarrior

/*** Window ****/
GameWindow::GameWindow()
:DataWindow("\pand you know that notion just crossed my mind",sptemp,FALSE)
{
	UpKey=0x5b;
	DownKey=0x54;
	LeftKey=0x56;
	RightKey=0x58;
	FireKey=0x52;
	
	//get ready for color animation
	
	((WindowPtr)theWindow)->portRect=qd.screenBits.bounds;
	ShowReferencedWindow(theWindow);
	SetPort((GrafPtr)theWindow);
	
	ForeColor(blackColor);
	BackColor(whiteColor);
	PaintRect(&((WindowPtr)theWindow)->portRect);	
	LoadEverything();
}

GameWindow::~GameWindow()
{
	KillEverything();
}

/** Menureceiver handling **/
/*void GameWindow::MenuCheck()
{
}*/

void GameWindow::ReceiveMenuCommand(OSType theCmd)
{
	switch(theCmd){
		case 'Begn':
			isGameOff=false;
			break;
		case 'Paus':
			if(isGameOff==true){
				isGameOff=false;
				SetItem(GetMHandle(gMenubase->mid),gMenubase->mitem,"\pPause");
			}else{
				isGameOff=true;
				SetItem(GetMHandle(gMenubase->mid),gMenubase->mitem,"\pResume");
			}
			break;
		case 'End ':
			isGameOff=true;
			RackEmUp();
			Draw();
			break;
	}
}

long spareticks=0;
long accum=0;
//long gSongIndex=0;
void GameWindow::SubEventLoop()
{
	//146
	/*RGBColor red={0xFFFF,0x0000,0x0000};
	RGBColor green={0x3333,0xFFFF,0x9999};
	RGBColor current;
	
	GetEntryColor(GetPalette((WindowPtr)theWindow),146,&current);
	
	if(current.red==red.red && current.green==0 && current.blue==0){
		AnimateEntry((WindowPtr)theWindow,146,&green);
	}else{
		AnimateEntry((WindowPtr)theWindow,146,&red);
	}*/
	
//	gSongIndex=SSE_ContinueMusic((Ptr)currentSong,gSongIndex,currentSongLen);
	
	pxblz_TimeShare();
	SetPort((GrafPtr)theWindow);
	pxblz_Draw(theWindow,sptemp);
	
	accum+=1;
	
	if(TickCount()-spareticks>60){
		Str255 str;
		
		SetPort((GrafPtr)theWindow);
		NumToString(accum,str);
		MoveTo(100,400);
		DrawString(str);
		DrawString("\p fps    ");
		accum=0;
		spareticks=TickCount();
	}
}

void GameWindow::LoadEverything()
{
	PicHandle	back;
	
	spareticks=TickCount();
	
	levelPolys=GetPolygons("\pLevel 1");
	if(levelPolys==NULL) DebugStr("\pCant find level polygons.");
//	level=(planeOfConfusion**)GetResource('LEVL',128);
//	HLockHi((Handle)level);
	
	back=(PicHandle)GetNamedResource('PICT',"\pLevel 1");
	if(back==NULL)  DebugStr("\pCan't get background PICT.");
	HLockHi((Handle)back);
	
	sptemp.left=0;
	sptemp.right=((WindowPtr)theWindow)->portRect.right;
	
	SetPort((WindowPtr)theWindow);
	TextMode(srcCopy);
	
	pxblz_Init(sptemp,back);
	
	HUnlock((Handle)back);
	ReleaseResource((Handle)back);
	
	OffsetRect(&sptemp,0,100);
	
	player=pxblz_NewSprite(128,135);
	pxblz_SetSpriteDelays(player,5,2);//delay between advancing frame, calling move proc
	player->itsMoveProc=&PlayerMoveProc;
	player->itsIsVisible=true;
	RackEmUp();
	
	shot=pxblz_NewSprite(501,502);
	pxblz_SetSpriteFrames(shot,0,1,0);
	pxblz_SetSpriteDelays(shot,1,3);
	
	/*enemy1=pxblz_NewSprite(201,208);
	enemy1->itsNumTicks=5;
//	enemy1->itsMoveProc=&GSMoveProc;
	pxblz_SetSpriteFrames(enemy1,0,1,0);*/
	
	isGameOff=true;
	
	oldShotTicks=TickCount();
	SSE_Init(3,5);
}

void GameWindow::MouseDown(EventRecord &)
{
	isGameOff=!isGameOff;
}

/*Do whatever's necessary to set up a new blank game.*/
void GameWindow::RackEmUp()
{
	pxblz_ResetAllSprites();	//return all sprites to 0,0
	pxblz_MoveSprite(player,+0,+70);
	pxblz_SetSpriteFrames(player,0,0,0);
//	pxblz_SetSpriteFrames(enemy1,0,0,0);

	
}

// * virtual Draw Window
void GameWindow::Draw()
{
	SetPort((WindowPtr)theWindow);
	
	ForeColor(blackColor);
	BackColor(whiteColor);
	PaintRect(&((WindowPtr)theWindow)->portRect);
	ForeColor(blueColor);
	InsetRect(&sptemp,-1,-2);
	FrameRect(&sptemp);
	InsetRect(&sptemp,-1,-2);
	FrameRect(&sptemp);
	InsetRect(&sptemp,-1,-2);
	FrameRect(&sptemp);
	InsetRect(&sptemp,3,6);
	ForeColor(whiteColor);
	BackColor(blackColor);
	pxblz_Draw(theWindow,sptemp);
}

/*Deallocate all*/
void GameWindow::KillEverything()
{
}

void GameWindow::Scroll(short h, short v)
{
	//SetPort((GrafPtr)theWindow);
	pxblz_ScrollBackground(h,v,sptemp);
}

/*
	We need three MoveProcs, one for the player, one for the shot sprites,
	one for the enemies.  We need to come up with a new algorithm for the last.
*/
extern Rect	backRect;

void PlayerMoveProc(Sprite* s)
{
	Boolean 		keysDown[5]={KeyIsDown(UpKey),KeyIsDown(DownKey),KeyIsDown(RightKey),KeyIsDown(LeftKey),KeyIsDown(FireKey)};
	Point			wh;
	Boolean			move=false;
	
	SetPort((GrafPtr)backG);	//ptinpoly creates a region!
		
	if(keysDown[0]){
		wh.h=s->itsRect.right;
		wh.v=s->itsRect.bottom-5;
		
		if(PtInPolys(levelPolys,&wh)){
			move=false;
		}else move=true;
		
		if(move==true){
			pxblz_MoveSprite(s,-1,-3);
		}
	}
	
	const short speed=4;
	if(keysDown[1]){
		pxblz_MoveSprite(s,+1,+3);
	}
	
	if(keysDown[2] && keysDown[3]==false){
		
		wh.h=s->itsRect.right;
		wh.v=s->itsRect.bottom;
		
		if(PtInPolys(levelPolys,&wh)){
			move=false;
		}else move=true;
		
		if(move==true){
			pxblz_SetSpriteFrames(s,0,3,s->itsCurrentFrame<4 ? s->itsCurrentFrame : 0);
	
			pxblz_MoveSprite(s,+speed,0);
			if(backRect.right-s->itsRect.right<=290){
				if(backRect.right!=((GrafPtr)backG)->portRect.right){
					gGameWindow->Scroll(+speed,0);
				}
			}
		}
	}
	
	if(keysDown[3] && keysDown[2]==false){
		
		wh.h=s->itsRect.left;
		wh.v=s->itsRect.bottom;
		
		if(PtInPolys(levelPolys,&wh)){
			move=false;
		}else move=true;
		
		if(move==true){
			pxblz_SetSpriteFrames(s,4,7,s->itsCurrentFrame>3 ? s->itsCurrentFrame : 4);
			pxblz_MoveSprite(s,-speed,0);
			
			if(backRect.right - s->itsRect.right >= 290){
				if(backRect.left != ((GrafPtr)backG)->portRect.left){
					gGameWindow->Scroll(-speed,0);
				}
			}
		}
	}
	
	if(keysDown[4]){
		if(TickCount()-oldShotTicks>=20){
			SSE_PlaySoundIndex(0);
			
			Sprite* t=pxblz_NewSpriteAlias(shot);
			t->itsIsVisible=true;
			if(s->itsCurrentFrame>3){
				pxblz_MoveSprite(t,s->itsRect.left-10,s->itsRect.top+20);
				t->itsMoveProc=&ShotMoveLeftProc;
				currentShot= kShotLeft;	//30
			}else{
				pxblz_MoveSprite(t,s->itsRect.right+10,s->itsRect.top+20);
				t->itsMoveProc=&ShotMoveRightProc;
				currentShot= kShotRight; //-30
			}
			t->itsMiscData=s->itsRect.bottom-4;	//the plane in which the user is in
			oldShotTicks=TickCount();
		}
	}
	
	//if were not walking, stop walking animation
	//need to figure out animation for up & down
	if(move!=true){
		pxblz_SetSpriteFrames(s,s->itsCurrentFrame,s->itsCurrentFrame,s->itsCurrentFrame);
	}
}

void ShotMoveLeftProc(Sprite* s)
{
	register short	j;
	Point			wh;
	Boolean			move=true;
	short			num=(GetHandleSize((Handle)levelPolys)/sizeof(poly4));	
	
	wh.h=s->itsRect.left;
	wh.v=s->itsMiscData;
	
	for(j=0;j<num;j++){
		if(PtInPoly(levelPolys,&wh,j)==true){
			move=false;
		}
	}//endfor

	pxblz_MoveSprite(s,-20,0);
	if(s->itsRect.left<backG->portRect.left||move==false){
		pxblz_InvalRect(s->itsOldRect);
		pxblz_DisposeSpriteAlias(s);
	}
}

void ShotMoveRightProc(Sprite* s)
{
	register short	j;
	Point			wh;
	Boolean			move=true;
	short			num=(GetHandleSize((Handle)levelPolys)/sizeof(poly4));	
	
	wh.h=s->itsRect.right;
	wh.v=s->itsMiscData;
	
	for(j=0;j<num;j++){
		if(PtInPoly(levelPolys,&wh,j)==true){
			move=false;
		}
	}//endfor
	
	pxblz_MoveSprite(s,20,0);
	if(s->itsRect.left>backG->portRect.right||move==false){
		pxblz_InvalRect(s->itsOldRect);
		pxblz_DisposeSpriteAlias(s);
	}
}

// * gray spirit enemy move proc
void GSMoveProc(Sprite* s)
{
	pxblz_MoveSprite();
}

Boolean KeyIsDown(short keyCode)
{
	union {
		KeyMap			asMap;
		unsigned char	asBytes[16];
	} myMap;
	
	GetKeys(myMap.asMap);
	return ((myMap.asBytes[keyCode >> 3] >> (keyCode & 0x07)) & 1) != 0;
}


		/*short	num=(GetHandleSize((Handle)level)/sizeof(planeOfConfusion));
		short	wh=s->itsRect.bottom;
		short	cuml=0;	//cuml is not cumling 
		
		for(short j=200;;){
			cuml+=1;
			j-=10;
			
			if(wh>=j){
				for(short i=0;i<=num;++i){
					if(s->itsRect.left<=(**level).gr[i].to && s->itsRect.left>=(**level).gr[i].from){
						
						switch((**level).gr[i].pixGroup[cuml]){
							case 0:
								pxblz_MoveSprite(s,-1,-3);
								break;
							case 1:
								break;
							case 2:
								break;
						}
					}
				}//endfor
				break;
			}
			
			if(j<=0)
				break;
		}*/