#pragma once

#include "CWindow.h"


/*itsPicture should be changed to Handle itsData, and an itsDraw
field should be added which is a function that can draw this specifc
sprite, if we want to make this package generic and fast.

If we just want to make it generic, we can make this a class and
have other classes inherit Draw(), HitYou(), and HouseKeep()
functions.*/

typedef struct Sprite{
	Rect		itsRect;		//current draw rect
	Rect		itsOldRect;		//last draw rect
	Rect		itsShapeRect;	//rect to get sprite from sprite GWorld
	RgnHandle	itsMaskRgn;		//maskRgn
	short		itsScaleFactor;	//how much do we magnify?
	void		(*itsDrawProc)(Sprite&);
	Boolean		itsIsVisible;
}Sprite;

typedef struct{
	struct{
		short	from;
		short	to;
		char	pixGroup[20];
	}gr[1];
}planeOfConfusion;

class GameWindow:public DataWindow{
protected:
	short		UpKey;
	short		DownKey;
	short		LeftKey;
	short		RightKey;
	short		FireKey;
	Sprite		player;
	Sprite		shot;
	

	Rect				over;
	Boolean				backNeedsUp;
	planeOfConfusion**	level;
public:
	GameWindow();
	~GameWindow();
	
	void LoadEverything();
	void KillEverything();
	
	Sprite &NewSprite(Rect &gRect);
	void KillSprite(Sprite &s);
	void DrawSprite(Sprite &s);
	void MoveSprite(Sprite& theSprite,short a,short b);
	void Draw();
	RgnHandle GetSomeSeriousUpdateRgn();
	void CheckKeys();
	Boolean KeyIsDown(short keyCode);
	
	PicHandle GetGWorldPictBounds(GWorldPtr gw,Rect &gRect);
	void fire();
	void up();
	void down();
	void left();
	void right();

	void SubEventLoop();
};

/*
	Boolean		a:1;
	Boolean		b:1;
	Boolean		c:1;
	Boolean		d:1;
	Boolean		e:1;
	Boolean		f:1;
	Boolean		g:1;
	Boolean		change:1;
	long		ticksBeforeChange;
	long		ticksDelta;
	short		*/