/*
	Polygon Manager
	1994 Chris K. Thomas.  All Rights Reserved.
	
*/

#include "polygons.h"
#include "directToolbox.h"
#pragma segment PolygonManager

static short pnpoly(short npol, short *xp, short *yp, short x, short y);

/* Poly creation */
ManyPoly **GetPolygons(Str255 &s)
{
	ManyPoly	**mp=NULL;
	
	mp=(ManyPoly**)GetNamedResource('POLY',s);
	if(mp!=NULL){
		HLockHi((Handle)mp);
		//short	numPoly=(GetHandleSize((Handle)mp)/sizeof(poly4));
	}
	return mp;
}


void DropPolygons(ManyPoly **mp)
{
	DisposeHandle((Handle)mp);
}

void AddPoly(ManyPoly **mp,poly4 *pAdd)
{
	short		num=(GetHandleSize((Handle)mp)/sizeof(poly4));
	
	SetHandleSize((Handle)mp,GetHandleSize((Handle)mp)+sizeof(poly4));
	(**mp).p[num+1]=*pAdd;
}

void DeletePoly(ManyPoly **mp,short index)
{
	short		num=(GetHandleSize((Handle)mp)/sizeof(poly4));
	short		numDelta=num-index;
	
	if(numDelta!=0)
		BlockMove(&(**mp).p[index],&(**mp).p[index+1],sizeof(poly4)*numDelta);
	
	SetHandleSize((Handle)mp,GetHandleSize((Handle)mp)-sizeof(poly4));
}

Boolean PtInPolys(ManyPoly **mp,Point *t)
{
	register short	j;
	short			num=(GetHandleSize((Handle)mp)/sizeof(poly4));
	
	for(j=0;j<num;j++){
		if(PtInPoly(mp,t,j)==true){
			return true;
		}
	}//endfor
	return false;
}

Boolean PtInPoly(ManyPoly **mp,Point *t,short which)
{
	Boolean		out=false;
	register short		x[4],y[4];
	
	HLock((Handle)mp);
		
	x[0]=(**mp).p[which].a.h;
	x[1]=(**mp).p[which].b.h;
	x[2]=(**mp).p[which].c.h;
	x[3]=(**mp).p[which].d.h;
	y[0]=(**mp).p[which].a.v;
	y[1]=(**mp).p[which].b.v;
	y[2]=(**mp).p[which].c.v;
	y[3]=(**mp).p[which].d.v;
	
	out=pnpoly(4,x,y,t->h,t->v);
	HUnlock((Handle)mp);
	
	return out;
}

short pnpoly(short npol, short *xp, short *yp, short x, short y)
{   
	register short i, j, c = 0;

	for (i = 0, j = npol-1; i < npol;j = i++) {
		if ((((yp[i]<=y) && (y<yp[j])) || ((yp[j]<=y)  
			&& (y<yp[i]))) &&
			(x < (xp[j] - xp[i]) * (y - yp[i]) /  
			(yp[j] - yp[i]) + xp[i]))
			c = !c;
		}
	return c;
}