/*
	Sultan Sound Engine 1.0
	1994 Chris K. Thomas.  All Rights Reserved.
	
	REQUIRES: Sound Manager >= 3
*/

#include "SSE.h"

#define maxSounds 10
#define maxChannels 8

struct{
	short			numChan;
	SndChannelPtr	chan[maxChannels];
	short			numSamples;
	Handle			samples[maxSounds];
}sound;

#pragma segment SSE
void SSE_Init(short numChannels,short numSounds)
{
	OSErr	theErr;
	short	i;
	
	if(numChannels>maxChannels) numChannels=maxChannels;
	
	--numChannels;
	sound.numChan=numChannels;
	
	for(i=0;i<sound.numChan;i++){
		theErr=SndNewChannel(&sound.chan[i],sampledSynth,initMono,NULL);
		if(theErr!=noErr) DebugStr("\pNot enough sound.");
	}
	
	if(numSounds>maxSounds) numSounds=maxSounds;
	for(i=0;i<numSounds;i++){
		sound.samples[i]=GetResource('snd ',8200+i);
		if(ResError()!=noErr) return;
		HLockHi(sound.samples[i]);
		++sound.numSamples;
	}
}

void SSE_PlaySoundIndex(short idx)
{
	SCStatus	theStats;
	short		i;
	
	for(i=0;i<sound.numChan;i++){
		OSErr theErr=SndChannelStatus(sound.chan[i],sizeof(SCStatus),&theStats);
		if(theStats.scChannelBusy||theErr!=noErr) continue;
		else{
			SndPlay(sound.chan[i],sound.samples[idx],TRUE);
			break;
		}
	}
}

long SSE_ContinueMusic(Ptr music,long musicindex,long len)
{
	opcode		currentEffect=(opcode)music[musicindex];
	long		data1=0L;
	long		data2=0L;
	char		spare[2];
	long		sparelong=0;
	SCStatus	theStats;
	
	data1+=music[musicindex+1];
	data2+=music[musicindex+2];
	
	OSErr theErr=SndChannelStatus(sound.chan[1],sizeof(SCStatus),&theStats);
	if(theStats.scChannelBusy||theErr!=noErr) return len;
	
	switch(currentEffect){
		case tempo:
			SSE_PlayEffect(currentEffect,(long)data1,1);
			musicindex+=1;
			break;
		case volume:
			spare[0]=data1;
			spare[1]=data2;
			BlockMove(&spare,&sparelong,2);
			SSE_PlayEffect(currentEffect,sparelong,1);
			musicindex+=2;
			break;
		case index:
			SSE_PlayEffect(currentEffect,(long)data1,1);
			musicindex+=1;
			break;
		case note:
			musicindex+=1;	//length
			for(short i=1;i<=data1;i++){
				SSE_PlayEffect(tempo,music[musicindex+2],1);
				SSE_PlayEffect(currentEffect,music[musicindex+1],1);
				musicindex+=2;
				
				if(music[musicindex]=='\0') break;
			}
			break;
	}
	
	musicindex+=1;
	if(musicindex>=len) musicindex=0;
	return musicindex;
}

short ourTempo=1000;
void SSE_PlayEffect(opcode effect,long data,short channelIdx)
{
	SndCommand	theCmd;
	long		spare;
	
	switch(effect){
		case tempo:
			//set the duration of each note
			ourTempo=data*10;
			break;
		case index:
			//install new sound in the music channel
			if(GetSoundHeaderOffset(sound.samples[data],&spare)==noErr){
				theCmd.cmd=soundCmd;
				theCmd.param1=0;
				theCmd.param2=(spare+(long)*sound.samples[data]);
			}else{
				return; //### should return error
			}
			break;
		case note:
			//actually play the sound
			theCmd.cmd=freqDurationCmd;
			theCmd.param1=ourTempo;
			theCmd.param2=data/*data*/;
			break;
		case volume:
			//set channel volume
			theCmd.cmd=volumeCmd;
			theCmd.param1=0;
			theCmd.param2=data;
			break;
	}
	SndDoCommand(sound.chan[channelIdx],&theCmd,TRUE);
}