#pragma once
/*
	Chris's songs
	For use with the sultan sound engine.
	1994 Chris K. Thomas.  All Rights Reserved.

*/

#include "SSE.h"

//freqs
const short a6=57;
const short b6=59;
const short c6=60;
const short d6=62;
const short e6=64;
const short f6=65;
const short g6=67;
const short a5=45;
const short b5=47;
const short c5=48;
const short d5=50;
const short e5=52;
const short f5=53;
const short g5=55;

//modifiers
const short sharp=1;

//durations
const short eat=25;
const short qtr=50;
const short hlf=100;
const short dot=150;
const short whl=200;

char nowhereMan[]={index,3,note,25,
			/*He's a real nowhere man...*/
			b6,qtr,b6,qtr,e6,hlf,d6+sharp,qtr,c6+sharp,qtr,
			b6,hlf,a6,qtr,a6,qtr,c6+sharp,qtr,c6,qtr,
			b6,qtr,a6,qtr,g5+sharp,hlf,
			/*making all his nowhere plans...*/
			f5,qtr,f5,qtr,a6,qtr,a6,qtr,g5+sharp,qtr,
			f5,qtr,e5,qtr,f5,qtr,e5,qtr,f5,qtr,e5,qtr,
			e5,qtr,
			'\0'};

char lessThanSong[]={
	index,3,note,4,
	b6,qtr,d6,eat,a5,qtr,d6,hlf,
	index,2,note,3,
	c6,qtr,c5,qtr,c6,hlf,
	'\0'};

char *currentSong=lessThanSong;
const long currentSongLen=21;

/*
sound <index>
Specify the sound's index value.

note <length> ?pitch? ?pitch? ?pitch?....
Length is the number of notes to come, and pitch is those notes.
Pitch is defined as, where middle C = 60:

volume <left> <right>
Sets the left and right stereo volumes accordingly.
If not stereo, loudest volume is used.

              A   A#   B    C    C#   D   D#    E     F   F#     G    G#

Interval 1                        1    2    3    4    5    6    7    8
Interval 2    9   10   11   12   13   14   15   16   17   18   19   20
Interval 3   21   22   23   24   25   26   27   28   29   30   31   32
Interval 4   33   34   35   36   37   38   39   40   41   42   43   44
Interval 5   45   46   47   48   49   50   51   52   53   54   55   56
Interval 6   57   58   59   60   61   62   63   64   65   66   67   68
Interval 7   69   70   71   72   73   74   75   76   77   78   79   80
Interval 8   81   82   83   84   85   86   87   88   89   90   91   92
Interval 9   93   94   95   96   97   98   99  100  101  102  103  104
Interval10  105  106  107  108  109  110  111  112  113  114  115  116
Interval11  117  118  119  120  121  122  123  124  125  126  127
*/